Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# Connection Class Reference

Represents a single TCP or UDP socket for input or output. More...

Inheritance diagram for Connection:

List of all members.

## Public Member Functions
| Connection (ConnectionManager manager, Socket_IP socket)
| Creates a connection.
bool | considerFlush ()
| Sends the most recently queued TCP datagram(s) if enough time has elapsed.
bool | flush ()
| Sends the most recently queued TCP datagram(s) now.
NetAddress | getAddress ()
| Returns the address bound to this connection, if it is a TCP connection.
bool | getCollectTcp ()
| Returns the current setting of "collect-tcp" mode.
double | getCollectTcpInterval ()
| Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
ConnectionManager | getManager ()
| Returns a pointer to the ConnectionManager object that serves this connection.
Socket_IP | getSocket ()
| Returns the internal Socket_IP that defines the connection.
| setCollectTcp (bool collect_tcp)
| Enables or disables "collect-tcp" mode.
| setCollectTcpInterval (double interval)
| Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
| setIpTimeToLive (int ttl)
| Sets IP time-to-live.
| setIpTypeOfService (int tos)
| Sets IP type-of-service and precedence.
| setKeepAlive (bool flag)
| Sets whether the connection is periodically tested to see if it is still alive.
| setLinger (bool flag, double time)
| Sets the time to linger on close if data is present.
| setMaxSegment (int size)
| Sets the maximum segment size.
| setNoDelay (bool flag)
| If flag is true, this disables the Nagle algorithm, and prevents delaying of send to coalesce packets.
| setRecvBufferSize (int size)
| Sets the size of the receive buffer, in bytes.
| setReuseAddr (bool flag)
| Sets whether local address reuse is allowed.
| setSendBufferSize (int size)
| Sets the size of the send buffer, in bytes.

## Detailed Description

Represents a single TCP or UDP socket for input or output.

## Constructor & Destructor Documentation

Connection | ( | ConnectionManager | manager,
|  | Socket_IP | socket
| ) |  |

Creates a connection.

Normally this constructor should not be used directly by user code; use one of the methods in ConnectionManager to make a new connection.

## Member Function Documentation

bool considerFlush | ( |  | ) |

Sends the most recently queued TCP datagram(s) if enough time has elapsed.

This only has meaning if set_collect_tcp() has been set to true.

bool flush | ( |  | ) |

Sends the most recently queued TCP datagram(s) now.

This only has meaning if set_collect_tcp() has been set to true.

NetAddress getAddress | ( |  | ) |

Returns the address bound to this connection, if it is a TCP connection.

bool getCollectTcp | ( |  | ) |

Returns the current setting of "collect-tcp" mode.

See set_collect_tcp().

double getCollectTcpInterval | ( |  | ) |

Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

ConnectionManager getManager | ( |  | ) |

Returns a pointer to the ConnectionManager object that serves this connection.

Socket_IP getSocket | ( |  | ) |

Returns the internal Socket_IP that defines the connection.

setCollectTcp | ( | bool | collect_tcp | ) |

Enables or disables "collect-tcp" mode.

In this mode, individual TCP packets are not sent immediately, but rather they are collected together and accumulated to be sent periodically as one larger TCP packet. This cuts down on overhead from the TCP/IP protocol, especially if many small packets need to be sent on the same connection, but it introduces additional latency (since packets must be held before they can be sent).

See set_collect_tcp_interval() to specify the interval of time for which to hold packets before sending them.

If you enable this mode, you may also need to periodically call consider_flush() to flush the queue if no packets have been sent recently.

setCollectTcpInterval | ( | double | interval | ) |

Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

setIpTimeToLive | ( | int | ttl | ) |

Sets IP time-to-live.

setIpTypeOfService | ( | int | tos | ) |

Sets IP type-of-service and precedence.

setKeepAlive | ( | bool | flag | ) |

Sets whether the connection is periodically tested to see if it is still alive.

setLinger | ( | bool | flag,
|  | double | time
| ) |  |

Sets the time to linger on close if data is present.

If flag is false, when you close a socket with data available the system attempts to deliver the data to the peer (the default behavior). If flag is false but time is zero, the system discards any undelivered data when you close the socket. If flag is false but time is nonzero, the system waits up to time seconds to deliver the data.

setMaxSegment | ( | int | size | ) |

Sets the maximum segment size.

setNoDelay | ( | bool | flag | ) |

If flag is true, this disables the Nagle algorithm, and prevents delaying of send to coalesce packets.

setRecvBufferSize | ( | int | size | ) |

Sets the size of the receive buffer, in bytes.

setReuseAddr | ( | bool | flag | ) |

Sets whether local address reuse is allowed.

setSendBufferSize | ( | int | size | ) |

Sets the size of the send buffer, in bytes.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties